=== debian/control ===
Source: pure-gl
Section: devel
Priority: extra
Maintainer: Albert Graef <aggraef@gmail.com>
Build-Depends: debhelper (>= 7.0.50~), pure-dev,
 libgl1-mesa-dev | libgl-dev,
 libglu1-mesa-dev | libglu-dev,
 freeglut3-dev
Standards-Version: 3.9.1
Homepage: http://purelang.bitbucket.org

Package: pure-gl
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}, pure-ffi
Description: OpenGL interface for the Pure programming language
 Pure is a modern-style functional programming language based on term
 rewriting. This package provides the necessary modules for doing OpenGL
 graphics in Pure.
